/*
**    TP 4ETI CPE Lyon
**    Copyright (C) 2012 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/




#ifndef SHADING_HPP
#define SHADING_HPP


namespace cpe
{

/** \brief Container for shading parameters (ambiant,diffuse,specular)*/
struct shading
{
        /** \brief direct constructor for the shading parameters */
        shading(const double& ambiant=0.1,const double& diffuse=0.6,const double& specular=0.4,const double& specular_exponent=2.0);


        /** \brief ambiant component */
        double ambiant;
        /** \brief diffuse component */
        double diffuse;
        /** \brief specular component */
        double specular;
        /** \brief specular exponent */
        double specular_exponent;

};
}

#endif
