/*
**    TP 4ETI CPE Lyon
**    Copyright (C) 2012 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <camera.hpp>
#include <p2d.hpp>

namespace cpe
{
camera::camera(const v3& position,const double& z_near_)
    :p(position),z_near(z_near_){}
const v3& camera::get_center() const {return p;}
const double& camera::get_z_near() const {return z_near;}

v3 camera::project(const v3& p) const
{
    // ********************************************* //
    // ********************************************* //
    //  TO DO: Projection de x
    //
    // P=[z_near,     0, 0, 0 ]
    //   [     0,z_near, 0, 0 ]
    //   [     0,     0, 1, 0 ]
    //   [     0,     0, 1, 0 ]
    //
    // ********************************************* //
    // ********************************************* //

    return p;
}

p2d camera::real_to_image_coordinate(const v3& p,const unsigned int& N_x,const unsigned int& N_y)
{
    p2d u=p2d(N_x+(p.x()-1.0)/(2.0)*N_x,-(p.y()-1.0)/(2.0)*N_y);
    return u;
}

}
