/*
**    TP 4ETI CPE Lyon
**    Copyright (C) 2012 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/



#include <vertex_shader.hpp>

#include <color.hpp>
#include <vertex.hpp>
#include <shading.hpp>
#include <light.hpp>
#include <camera.hpp>
#include <color.hpp>

#include <cmath>

namespace cpe
{

color vertex_shader::compute_color(const vertex& v,const shading& shading_param,const light& light_param,const camera& camera_param)
{
    // ********************************************* //
    // ********************************************* //
    //  TO DO: Calcul d'illumination pour un sommet 3D + normal + couleur original
    //
    // ALGORITHM:
    //
    // | c0 <- couleur initiale
    // | d <- vecteur unitaire pointant vers la source lumineuse
    // | t <- vecteur unitaire pointant vers la camera
    // | s <- symétrique de t par rapport à la normale
    // |
    // | c_ambiant = ambiant * c0
    // | c_diffus  = cos^n(normal,d) * c0;
    // | c_specular= cos^m(s,d)
    // |
    // | c = c_ambiant + c_diffus + c_specular
    // |
    // ********************************************* //
    // ********************************************* //

    return v.c;


}

}
