/*
**    TP 4ETI CPE Lyon
**    Copyright (C) 2012 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef SCANLINE_DATA
#define SCANLINE_DATA

namespace cpe
{

/** \brief Storage for local info for a scanline_data (y-coord, alpha, line_index)*/
struct info_pixel
{
        /** \brief constructor */
        info_pixel();
        /** \brief full constructor */
        info_pixel(const int& y,const double& alpha,const int& line_index);

        /** \brief the y-coordinate */
        int y;
        /** \brief the relative position in the segment */
        double alpha;
        /** \brief the edge number of the triangle (0,1,2) */
        int line_index;
};


/** \brief Storage structure for scanline data*/
struct scanline_data
{
        /** \brief constructor : init info_min and info_max at (+infinity,-infinity) by default */
        scanline_data();
        /** \brief full constructor */
        scanline_data(const int& x,const info_pixel& info_min,const info_pixel& info_max);

        /** \brief current x-coordinate*/
        int x;
        /** \brief the infos of the min pixel (in y direction) */
        info_pixel info_min;
        /** \brief the infos of the max pixel (in y direction) */
        info_pixel info_max;
};

}


#endif
