/*
**    TP 4ETI CPE Lyon
**    Copyright (C) 2012 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/




#include <p2d.hpp>

namespace cpe
{

    p2d::p2d():internal_x(0),internal_y(0){}
    p2d::p2d(const int& x0,const int& y0):internal_x(x0),internal_y(y0){}

    void p2d::set(const int& x,const int& y){internal_x=x;internal_y=y;}


    const int& p2d::x() const{return internal_x;}
    int& p2d::x(){return internal_x;}
    const int& p2d::y() const{return internal_y;}
    int& p2d::y(){return internal_y;}

    std::ostream& operator<<(std::ostream& stream,const p2d& u)
    {
        stream<<u.x()<<" "<<u.y();
        return stream;
    }

    p2d operator+(const p2d& u1,const p2d& u2){return p2d(u1.x()+u2.x(),u1.y()+u2.y());}
    p2d operator-(const p2d& u1,const p2d& u2){return p2d(u1.x()-u2.x(),u1.y()-u2.y());}
    p2d& p2d::operator+=(const p2d& u){internal_x+=u.x();internal_y+=u.y();return *this;}
    p2d& p2d::operator-=(const p2d& u){internal_x-=u.x();internal_y-=u.y();return *this;}

}
