
/** TP 4ETI - CPE Lyon - 2011-2012 */

#include <iostream>
#include <cstdlib>

#include <camera.hpp>
#include <light.hpp>
#include <mesh.hpp>
#include <render_engine.hpp>
#include <shading.hpp>
#include <triangle.hpp>
#include <v3.hpp>
#include <vertex.hpp>

#include <color.hpp>
#include <image.hpp>
#include <image_drawable.hpp>
#include <image_drawable_zbuffer.hpp>
#include <p2d.hpp>
#include <pixel_interp.hpp>



using namespace cpe;

int main(int argc,char *argv[])
{

    std::cout<<"****"<<std::endl;
    std::cout<<"run "<<argv[0]<<" with "<<argc-1<<" parameters ... \n"<<std::endl;

    try
    {
        //image de taille 15x15
        image_drawable im(15);
        //remplissage en blanc
        im.fill(color(255,255,255));

        //dessigne ligne entre (2,3) et (13,10) de couleur (r,g,b)=(150,0,0)
        im.line(p2d(2,3),p2d(13,10),color(150,0,0));

        //sauve l'image dans un fichier
        std::cout<<"Draw picture on disk ..."<<std::endl;
        im.export_file("my_pic.ppm");
        std::cout<<"[OK]"<<std::endl;
    }
    catch(exception_cpe e)
    {
        std::cout<<"**********************************"<<std::endl;
        std::cout<<"**********************************"<<std::endl;
        std::cout<<"Exception found"<<std::endl;
        std::cout<<e.info()<<std::endl;
        std::cout<<"**********************************"<<std::endl;
        std::cout<<"**********************************"<<std::endl;
        exit(1);
    }


    std::cout<<"Exit Main"<<std::endl;

    return 0;
}
